
class Person
{
	String name;
	int alter;
	final boolean weiblich;

	Person sageName() { 
		System.out.println(name); 
		return this;
	}
	Person sageAlter() { 
		System.out.println(alter);	
		return this;
	}
	Person sageGeschlecht() { 
		System.out.println(weiblich ? "weiblich" : "maennlich");
		return this;
	}

	Person() // Standardkonstruktor
	{
		weiblich = false; // muss angegeben werden, da weiblich final ist
		name = "Unbekannt";
	}

	Person(String name, int alter, boolean weiblich)
	{
		this.name = new String(name); // warum geht nicht this.name = name ? -> Shallow Copy!
		this.alter = alter;
		this.weiblich = weiblich;
	}
	Person(final Person o)
	{
		this.name = o.name;
		this.alter = o.alter;
		this.weiblich = o.weiblich;
	}

}

class CopyKonstruktor
{
	public static void main(String[] args)
	{
		Person seppl = new Person("Seppl", 23, false);
		Person sophia = new Person("Sopia", 27, true);
		Person klon = new Person(seppl);
		seppl = sophia; // hier wird nicht geklont! Seppl IST damit sophia
		seppl.name = "Sepp";
	
		seppl.sageName().sageAlter().sageGeschlecht();
		sophia.sageName().sageAlter().sageGeschlecht();
		klon.sageName().sageAlter().sageGeschlecht();

	}
}
