
class Fehler extends Throwable
{
	String str;
	Fehler(String str)
	{
		this.str = str;
	}
}

class Exceptions
{
	public static void main(String[] args)
	{
		try
		{
			if(args.length == 0) throw new Fehler("Keine Argumente!");
			int i = Integer.parseInt(args[0]);
			if(i == 0) throw new Fehler("i ist Null!");
		}
		catch(NumberFormatException e)
		{
			System.out.println(e);
		}
		catch(Fehler e)
		{
			System.out.println(e.str);
		}
		finally
		{
			System.out.println("Programmende.");
		}
	}
}
