import java.io.File;
import java.util.Scanner;
import java.io.*;

class FileStreams
{
	public static void main(String[] args)
	{
		try
		{
			File f = new File("./dir");
			if(!f.exists() &&!f.mkdirs())
			{
				System.out.println("Kann Verzeichnis nicht anlegen");
				System.exit(1);
			}
			f = new File("./dir/datei.txt");
			if(!f.exists())
			{
				if(!f.createNewFile() || !f.canWrite())
				{
					System.out.println("Kann Datei nicht beschreiben!");
					System.exit(1);
				}
				Scanner s = new Scanner(System.in);


				do
				{
					System.out.println("Doublezahl: ");
					if(!s.hasNextDouble()) s.next();
				}
				while(!s.hasNextDouble());
				double d = s.nextDouble();


				do
				{
					System.out.println("Bytezahl: ");
					if(!s.hasNextByte()) s.next();
				}
				while(!s.hasNextByte());
				byte b = s.nextByte();


				DataOutputStream o = new DataOutputStream(new FileOutputStream(f));
				try
				{
					o.writeDouble(d);
					o.writeByte(b);
				}
				catch(java.io.IOException e) {}
				finally { o.close(); }
			}
			else
			{
				if(!f.canRead())
				{
					System.out.println("Kann Datei nicht anlegen/lesen");
					System.exit(1);
				}
				DataInputStream in = new DataInputStream(new FileInputStream(f));
				double d = in.readDouble();
				byte b = in.readByte();
				in.close();

				System.out.println("d: " + d + "\n" + b);
				if(!f.delete())
				{
					System.out.println("Kann Datei nicht löschen");
					System.exit(1);
				}
			}

		} 
		catch(java.io.IOException e) {}
	}
}
