interface Tier
{
	abstract public void gibLaut();
}

abstract class Haustier implements Tier
{
}

class Hund extends Haustier
{
	public void gibLaut()
	{
		System.out.println("Wuff!");
	}
}

class Katze extends Haustier
{
	public void gibLaut()
	{
		System.out.println("Miau");
	}
}

class Vogel extends Haustier
{
	public void gibLaut()
	{
		System.out.println("Piep");
	}
}


class InstanceOf 
{
	public static void streichle(Tier t)
	{
		if(t instanceof Katze || t instanceof Hund)
			System.out.println("*streichel*");
		else
			System.out.println("Kann dieses Tier nicht streicheln");
	}

	public static void main(String[] args)
	{
		Haustier[] tiere = { new Hund(), new Katze(), new Vogel() };
		for(Haustier t : tiere)
		{
			t.gibLaut();
			streichle(t);
		}
	}
}
