
/* Wir haben eine Zahl r (r Rational) und wollen in diesem Programm 
 * x := z*n auf zwei Arten berechnen:
 * a) x = z*n
 * b) x = z + z + ... + z (n-mal) 
 * Wenn a) und b) verschieden sind, haben wir einen Rundungsfehler!
 */

//strictfp 
class RoundOffError 
// Das strictfp-Schlüsselwort besagt, dass sich Java an den Standard halten soll und keine plattformabhängigen Optimierungen machen soll
// -> damit bleibt der Rundungsfehler bei allen Rechnern gleich (schlecht).
{
	public static void main(String[] args)
	{
		float z = 0.123f;
		float a = 0, b = 0;

		int i = 0; // Zählvariable
		do // tue
		{
			i = i+1; // erhöhe i um eins
			a = z*i; // a) z wird mit i multipliziert
			b += z; // b) z wird i-mal aufsummiert
			System.out.println("" + i + '\t' + a + '\t' + b + '\t' + (a-b));
		}
		while(a == b); // solange a gleich b ist
	}
}
