import java.util.Observable;
import java.util.Observer;


public class beobachter 
{
	
	static class Beobachter implements Observer
	{
		@Override
		public void update(Observable o, Object arg) 
		{
			System.out.println("Slot: Beobachte " + arg);
		}
		
	}
	static class Tuwas extends Observable implements Runnable
	{

		@Override
		public void run() 
		{
			for(int i = 0; i < 10; ++i)
			{
				notifyObservers();
				try 
				{
					Thread.sleep((int) (Math.random()*500));
				} 
				catch (InterruptedException e) 
				{
					e.printStackTrace();
				}
				setChanged();
				notifyObservers(i);
			}
			
		}
		
	}
	
	
	
	public static void main(String[] args) throws InterruptedException
	{
		Tuwas objekt = new Tuwas();
		objekt.addObserver(new Beobachter());
		Thread t = new Thread(objekt);
		
		t.start();
		while(t.isAlive())
		{
			objekt.notifyObservers();
			Thread.sleep(100);
		}
	}
}
