enum Richtung
{
	LINKS (0),
	RECHTS (1),
	OBEN (2),
	UNTEN (3);

	private int zahl;
	private Richtung(int i)
	{
		this.zahl = i;
	}
	void nach()
	{
		System.out.print("Nach ");
		switch(this)
		{
			case LINKS:
				System.out.println("links");
				break;
			case RECHTS:
				System.out.println("rechts");
				break;
			case OBEN:
				System.out.println("oben");
				break;
			case UNTEN:
				System.out.println("unten");
				break;
			default:
				System.out.println("nirgends");
		}
	}
}

class Enums
{
	public static void main(String[] str)
	{
		System.out.println("Wohin geht's?");
		Richtung richt = Richtung.LINKS;
		richt.nach();
		Richtung.LINKS.nach();
		Richtung.RECHTS.nach();
		Richtung.OBEN.nach();
		Richtung.UNTEN.nach();
		// oder:
		for(Richtung r : Richtung.values())
		{
			r.nach();
		}

	}
}
